/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-20 19:08:55 UTC)
 * on 2013-06-21 at 18:34:14 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.adsense.model;

/**
 * Model definition for ReportingMetadataEntry.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the AdSense Management API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ReportingMetadataEntry extends com.google.api.client.json.GenericJson {

  /**
   * For metrics this is a list of dimension IDs which the metric is compatible with, for dimensions
   * it is a list of compatibility groups the dimension belongs to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> compatibleDimensions;

  /**
   * The names of the metrics the dimension or metric this reporting metadata entry describes is
   * compatible with.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> compatibleMetrics;

  /**
   * Unique identifier of this reporting metadata entry, corresponding to the name of the
   * appropriate dimension or metric.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Kind of resource this is, in this case adsense#reportingMetadataEntry.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The names of the dimensions which the dimension or metric this reporting metadata entry
   * describes requires to also be present in order for the report to be valid. Omitting these will
   * not cause an error or warning, but may result in data which cannot be correctly interpreted.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> requiredDimensions;

  /**
   * The names of the metrics which the dimension or metric this reporting metadata entry describes
   * requires to also be present in order for the report to be valid. Omitting these will not cause
   * an error or warning, but may result in data which cannot be correctly interpreted.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> requiredMetrics;

  /**
   * The codes of the projects supported by the dimension or metric this reporting metadata entry
   * describes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> supportedProducts;

  /**
   * For metrics this is a list of dimension IDs which the metric is compatible with, for dimensions
   * it is a list of compatibility groups the dimension belongs to.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getCompatibleDimensions() {
    return compatibleDimensions;
  }

  /**
   * For metrics this is a list of dimension IDs which the metric is compatible with, for dimensions
   * it is a list of compatibility groups the dimension belongs to.
   * @param compatibleDimensions compatibleDimensions or {@code null} for none
   */
  public ReportingMetadataEntry setCompatibleDimensions(java.util.List<java.lang.String> compatibleDimensions) {
    this.compatibleDimensions = compatibleDimensions;
    return this;
  }

  /**
   * The names of the metrics the dimension or metric this reporting metadata entry describes is
   * compatible with.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getCompatibleMetrics() {
    return compatibleMetrics;
  }

  /**
   * The names of the metrics the dimension or metric this reporting metadata entry describes is
   * compatible with.
   * @param compatibleMetrics compatibleMetrics or {@code null} for none
   */
  public ReportingMetadataEntry setCompatibleMetrics(java.util.List<java.lang.String> compatibleMetrics) {
    this.compatibleMetrics = compatibleMetrics;
    return this;
  }

  /**
   * Unique identifier of this reporting metadata entry, corresponding to the name of the
   * appropriate dimension or metric.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Unique identifier of this reporting metadata entry, corresponding to the name of the
   * appropriate dimension or metric.
   * @param id id or {@code null} for none
   */
  public ReportingMetadataEntry setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Kind of resource this is, in this case adsense#reportingMetadataEntry.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is, in this case adsense#reportingMetadataEntry.
   * @param kind kind or {@code null} for none
   */
  public ReportingMetadataEntry setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The names of the dimensions which the dimension or metric this reporting metadata entry
   * describes requires to also be present in order for the report to be valid. Omitting these will
   * not cause an error or warning, but may result in data which cannot be correctly interpreted.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getRequiredDimensions() {
    return requiredDimensions;
  }

  /**
   * The names of the dimensions which the dimension or metric this reporting metadata entry
   * describes requires to also be present in order for the report to be valid. Omitting these will
   * not cause an error or warning, but may result in data which cannot be correctly interpreted.
   * @param requiredDimensions requiredDimensions or {@code null} for none
   */
  public ReportingMetadataEntry setRequiredDimensions(java.util.List<java.lang.String> requiredDimensions) {
    this.requiredDimensions = requiredDimensions;
    return this;
  }

  /**
   * The names of the metrics which the dimension or metric this reporting metadata entry describes
   * requires to also be present in order for the report to be valid. Omitting these will not cause
   * an error or warning, but may result in data which cannot be correctly interpreted.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getRequiredMetrics() {
    return requiredMetrics;
  }

  /**
   * The names of the metrics which the dimension or metric this reporting metadata entry describes
   * requires to also be present in order for the report to be valid. Omitting these will not cause
   * an error or warning, but may result in data which cannot be correctly interpreted.
   * @param requiredMetrics requiredMetrics or {@code null} for none
   */
  public ReportingMetadataEntry setRequiredMetrics(java.util.List<java.lang.String> requiredMetrics) {
    this.requiredMetrics = requiredMetrics;
    return this;
  }

  /**
   * The codes of the projects supported by the dimension or metric this reporting metadata entry
   * describes.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getSupportedProducts() {
    return supportedProducts;
  }

  /**
   * The codes of the projects supported by the dimension or metric this reporting metadata entry
   * describes.
   * @param supportedProducts supportedProducts or {@code null} for none
   */
  public ReportingMetadataEntry setSupportedProducts(java.util.List<java.lang.String> supportedProducts) {
    this.supportedProducts = supportedProducts;
    return this;
  }

  @Override
  public ReportingMetadataEntry set(String fieldName, Object value) {
    return (ReportingMetadataEntry) super.set(fieldName, value);
  }

  @Override
  public ReportingMetadataEntry clone() {
    return (ReportingMetadataEntry) super.clone();
  }

}
